

# We can run on Rhel 3'ish systems, but only if python2.3 is installed 
%if 0%{?rhel} == 3
%define __python_ver 2.3
%endif
%define python python%{?__python_ver}
%define __python /usr/bin/%{python}


%{!?python_version: %define python_version %(%{__python} -c "from distutils.sysconfig import get_python_version; print get_python_version()")}
%{!?python_sitelib: %define python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}

%define is_suse %(test -e /etc/SuSE-release && echo 1 || echo 0)


Summary: Remote certificate distribution framework
Name: certmaster
Version: 0.28
Release: 1.1
Source0: %{name}-%{version}.tar.gz
Source1: %{name}.service
License: GPLv2+
Group: Applications/System
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot
BuildArch: noarch
Url: https://fedorahosted.org/certmaster

%if 0%{?rhel} == 3
Requires: %{python}
Requires: pyOpenSSL-py23
%else
Requires: python >= 2.3 redhat-rpm-config
Requires: pyOpenSSL
%endif

# NOTE: if you 
BuildRequires: %{python}-devel
%if 0%{?is_suse} == 1
BuildRequires: gettext-devel
%else
%if 0%{?fedora} >= 8
BuildRequires: python-setuptools
%else
%if 0%{?rhel} >= 5
BuildRequires: python-setuptools
%endif
%endif
%endif
%if 0%{?fedora} >= 16 || 0%{?rhel} >= 7
BuildRequires: systemd-units
Requires(post): systemd-sysv
Requires(post): systemd-units
Requires(preun): systemd-units
Requires(postun): systemd-units
%endif



%description

certmaster is a easy mechanism for distributing SSL certificates

%prep
%setup -q

%build
%{__python} setup.py build

%install
test "x$RPM_BUILD_ROOT" != "x" && rm -rf $RPM_BUILD_ROOT
%{__python} setup.py install --prefix=/usr --root=$RPM_BUILD_ROOT
ln -s %{_bindir}/certmaster-sync $RPM_BUILD_ROOT/var/lib/certmaster/triggers/sign/post/certmaster-sync
ln -s %{_bindir}/certmaster-sync $RPM_BUILD_ROOT/var/lib/certmaster/triggers/remove/post/certmaster-sync
touch $RPM_BUILD_ROOT/var/log/certmaster/certmaster.log
touch $RPM_BUILD_ROOT/var/log/certmaster/audit.log

# systemd
%if 0%{?fedora} >= 16  || 0%{?rhel} >= 7
rm -rf $RPM_BUILD_ROOT/etc/init.d/
mkdir -p $RPM_BUILD_ROOT%{_unitdir}
install -m0644 %{SOURCE1} $RPM_BUILD_ROOT%{_unitdir}/
%endif

%clean
rm -fr $RPM_BUILD_ROOT

%files
%defattr(-, root, root, -)
%if "%{python_version}"  >= "2.5"
%{python_sitelib}/certmaster*.egg-info
%endif
%{_bindir}/certmaster
%{_bindir}/certmaster-request
%{_bindir}/certmaster-ca
%{_bindir}/certmaster-sync
%if 0%{?fedora} >= 16 || 0%{?rhel} >= 7
%{_unitdir}/certmaster.service
%else
/etc/init.d/certmaster
%endif
%dir %{_sysconfdir}/%{name}
%dir %{_sysconfdir}/%{name}/minion-acl.d/
%dir %{_sysconfdir}/pki/%{name}
%config(noreplace) /etc/certmaster/minion.conf
%config(noreplace) /etc/certmaster/certmaster.conf
%config(noreplace) /etc/logrotate.d/certmaster_rotate
%config /etc/certmaster/version
%dir %{python_sitelib}/certmaster
%{python_sitelib}/certmaster/*.py*

%dir /var/log/certmaster
%attr(0600,root,root)  %config(noreplace) %verify(not md5 size mtime) /var/log/certmaster/certmaster.log
%attr(0600,root,root)  %config(noreplace) %verify(not md5 size mtime) /var/log/certmaster/audit.log

%attr(600,root,root) %dir /var/lib/certmaster
%attr(600,root,root) %dir /var/lib/certmaster/certmaster
%attr(600,root,root) %dir /var/lib/certmaster/certmaster/certs
%attr(600,root,root) %dir /var/lib/certmaster/certmaster/csrs
%dir /var/lib/certmaster/peers
%dir /var/lib/certmaster/triggers/sign/
%dir /var/lib/certmaster/triggers/sign/pre
%dir /var/lib/certmaster/triggers/sign/post
%dir /var/lib/certmaster/triggers/request/
%dir /var/lib/certmaster/triggers/request/pre
%dir /var/lib/certmaster/triggers/request/post
%dir /var/lib/certmaster/triggers/remove/
%dir /var/lib/certmaster/triggers/remove/pre
%dir /var/lib/certmaster/triggers/remove/post
/var/lib/certmaster/triggers/sign/post/certmaster-sync
/var/lib/certmaster/triggers/remove/post/certmaster-sync
%doc AUTHORS README LICENSE
%{_mandir}/man1/*.1.gz

%if 0%{?fedora} >= 16  || 0%{?rhel} >= 7
%post
if [ $1 -eq 1 ] ; then 
    # Initial installation 
    /bin/systemctl daemon-reload >/dev/null 2>&1 || :
fi
# fix perms on log files
chmod 600 /var/log/certmaster/certmaster.log
chmod 600 /var/log/certmaster/audit.log

%preun
if [ $1 -eq 0 ] ; then
    # Package removal, not upgrade
    /bin/systemctl --no-reload disable certmaster.service > /dev/null 2>&1 || :
    /bin/systemctl stop certmaster.service > /dev/null 2>&1 || :
fi

%postun
/bin/systemctl daemon-reload >/dev/null 2>&1 || :
if [ $1 -ge 1 ] ; then
    # Package upgrade, not uninstall
    /bin/systemctl try-restart certmaster.service >/dev/null 2>&1 || :
fi

%triggerun -- certmaster < 0.28-2
# Save the current service runlevel info
# User must manually run systemd-sysv-convert --apply certmaster
# to migrate them to systemd targets
/usr/bin/systemd-sysv-convert --save certmaster >/dev/null 2>&1 ||:

# Run these because the SysV package being removed won't do them
/sbin/chkconfig --del certmaster >/dev/null 2>&1 || :
/bin/systemctl try-restart certmaster.service >/dev/null 2>&1 || :

%else

%post
# for suse 
if [ -x /usr/lib/lsb/install_initd ]; then
  /usr/lib/lsb/install_initd /etc/init.d/certmaster
# for red hat distros
elif [ -x /sbin/chkconfig ]; then
  /sbin/chkconfig --add certmaster
# or, the old fashioned way
else
   for i in 2 3 4 5; do
        ln -sf /etc/init.d/certmaster /etc/rc.d/rc${i}.d/S99certmaster
   done
   for i in 1 6; do
        ln -sf /etc/init.d/certmaster /etc/rc.d/rc${i}.d/k01certmaster
   done
fi
exit 0
# fix perms on log files
chmod 600 /var/log/certmaster/certmaster.log
chmod 600 /var/log/certmaster/audit.log

%preun
if [ "$1" = 0 ] ; then
  /etc/init.d/certmaster stop  > /dev/null 2>&1
  if [ -x /usr/lib/lsb/remove_initd ]; then
    /usr/lib/lsb/remove_initd /etc/init.d/certmaster
  elif [ -x /sbin/chkconfig ]; then
    /sbin/chkconfig --del certmaster
  else
    rm -f /etc/rc.d/rc?.d/???certmaster
  fi
fi
%endif


%changelog
